/**********************************************************
	eval.h
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
	Kirill Mechitov (mechitov@cs.uiuc.edu)
**********************************************************/
#ifndef _EVAL_H
#define _EVAL_H

#include "memory.h"
typedef struct {
	uint16_t nil;
	uint16_t true;
	uint16_t false;
	uint16_t lambda;
	uint16_t rec;
	uint16_t cond;
	uint16_t halt;
	uint16_t cond_;
	uint16_t apply;
	uint16_t closure;
	uint16_t quote;

	uint16_t add;
	uint16_t sub;
	uint16_t mul;
	uint16_t div;

	uint16_t equal;
	uint16_t gt;
	uint16_t ge;
	uint16_t lt;
	uint16_t le;

	uint16_t and_;
	uint16_t or_;
	uint16_t not_;

	uint16_t cons;
	uint16_t car;
	uint16_t cdr;
	uint16_t list;
	uint16_t set;
	uint16_t setcar;
	uint16_t setcdr;

	uint16_t io;
	uint16_t print;
	uint16_t send;
	uint16_t id;
	uint16_t msgq;

	uint16_t sleep;

	uint16_t eval;
	uint16_t callcc;
	uint16_t seq;
	uint16_t par;
	uint16_t prim;
	uint16_t extmsg;
	uint16_t last;

} Symbols;
#ifdef PC
extern char *keyword[];
#endif
extern Symbols sym;
extern uint16_t baseEnv, nilAdrs;
void initEnv();
void *deref(uint16_t a);	//dereference the address a. because of VM management it is volatile
uint16_t haltCont(uint16_t id);
uint16_t getId(uint16_t cont);
uint16_t getMsgQ(uint16_t cont);
uint16_t extendEnv(uint16_t env, uint16_t ids, uint16_t values);
uint16_t lookup(uint16_t env, uint16_t id);
uint16_t reverse(uint16_t l);					//reverse a list l
void apply(uint16_t cont, uint16_t v);
void eval(uint16_t expr, uint16_t env, uint16_t cont);

#endif /* _EVAL_H */
