/**********************************************************
	extcomm.h
	version 1.0
	Sergei Shevlyagin (shevlyag@uiuc.edu)
**********************************************************/
#ifndef _EXTCOMM_H
#define _EXTCOMM_H

// necessary for mutexes
#ifdef PC
#include <pthread.h>
#endif
#include "memory.h"
// Enables(1) or disables(0) debug printing
#define Debug 0
// speed for PC
#define Throttle 100  
// troll level 100 no misses
#define TrollLevel 80	
// dead platform
#define GiveUp 0xff

// Message structure for sending an acknowledgement from stop and go

typedef struct {
	uint16_t rxId;
	uint8_t rxSeqNo;
	uint16_t txId;
	uint8_t txSeqNo;
} acknowledgement; 


// Message structure for keeping track of last message in simple ack protocol
typedef struct {
		uint16_t senderId;
		uint8_t seqNo;
		uint8_t ok; 
} lastMessage;



void initSP(void(*newsP)(uint8_t *, uint8_t));

#ifdef PC
void debugPrint(uint8_t *debugname, uint8_t *data, uint8_t n);
void debugAck(uint8_t *text, acknowledgement ack);
#endif
// wrapper for simple ack
void sendPacketAck(uint8_t *buf, uint8_t n, lastMessage lm[], uint8_t lmi);
// PC timer functions


void setup_timer_resend(uint8_t delay);
void kill_timer_resend();
void timer_handler_resend(); 
uint8_t getTimerFlag();
void setTimerFlag(uint8_t val);

#ifdef PC
void setup_timer_throttle();
void kill_timer_throttle();
void timer_handler_throttle(); 
uint8_t message_troll();
#endif

#endif /* _EXTCOMM_H */
