/**********************************************************
	memory.h
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
**********************************************************/
#ifndef _MEMORY_H
#define _MEMORY_H

#ifdef PC
#define NumPage		8
#else
#define NumPage		8
#endif
#define PageSize	112
#define	FlashSize	(64*1024L)
#define HeadPage NumPage
#define MaxAddress	(FlashSize/sizeof(Page)*PageSize)

#ifndef PC
	#include <inttypes.h>
#else
	#include <stdint.h>
/*
typedef unsigned int uint32_t;
typedef unsigned short uint16_t;
typedef unsigned char uint8_t;
*/
#endif

#ifdef STAT
typedef struct {
	int	hit, miss;
	int	wr, rd;
	int	ngc, gcwr, maxgcwr, regc, markwr, nmark;
} Stat;
Stat stat;
#endif

typedef struct {
	uint8_t next;
	uint16_t page;
} InversePageTable;
typedef struct {
	uint8_t memory[PageSize];
	uint8_t bitmap[14];
	union {
		uint8_t reserved[2];
		struct {
			uint8_t dirty:1;
			uint8_t lock:4;
		} flag;
	} bits;
} Page;

void initVM();
uint8_t* fetch(uint16_t addr, uint8_t wr);
uint16_t reserve(uint8_t n);	//n should be less than 111 (1 byte is used for book keeping)
void release(uint16_t addr, uint8_t n);
uint8_t isReserved(uint16_t addr);
uint8_t *lock(uint16_t addr, uint8_t rw);
uint8_t *unlock(uint16_t addr, uint8_t rw);
extern uint16_t reserveStartPage, reserveEndPage;	//from where search begins and ends for reservation

#endif /* _MEMORY_H */
