/**********************************************************
	thread.h
	version 1.1
	YoungMin Kwon (ykwon4@cs.uiuc.edu)
**********************************************************/
#ifndef _THREAD_H
#define _THREAD_H

#include <setjmp.h>
#include "memory.h"
#define MaxThread 10
typedef enum {
	ThreadReady, ThreadSleep, ThreadRun
} ThreadState;
typedef struct {
	uint16_t cont[MaxThread];
	uint16_t value[MaxThread];
	uint8_t state[MaxThread];
	uint8_t h, t;
	uint8_t (*next)(uint8_t p);		//next index of head and tail

	//to resume after return from a non-blocking func. like Log
	void (*start)(void *arg);	//start func
	void *start_arg;			//argument of the start func
	int	stack_gap_size;			//stack size for tinyOs
	uint8_t yielded;			//whether it was yielded
	jmp_buf toTos, toCont;	//to tinyOs, to continue
} Thread;
extern Thread thr;
void initThread();
void addThread(uint16_t cont, uint16_t value);
void addThreadInState(uint16_t cont, uint16_t value, uint8_t state);
void runThread();
void wakeupThreads();
void yield();
uint8_t resume();
void run(void (*start)(void*), void *arg, uint16_t stack_gap_size);

#endif /* _THREAD_H */
